<?php
require_once 'include/_universal.php';
$x = new universal('prizes','prize',2);
$x->database('prizes','prizeid','prizename');
$x->permissions('add',1);
$x->permissions('mod',1);
$x->permissions('del',1);
$x->add_notes('add','list the prizes that you have available to give away here.  if the prize is to be given away in a tournament, list the tournament and the placing.  if you have more than one of a prize and wish to give them out to different tournaments, please list them seperately.');

$x->add_related_link('prize control panel','admin_prize_control.php',2);
$x->add_related_link('print off prize slips for drawing.','admin_prizes_print.php',2);
$x->add_related_link('draw prizes interactively.','admin_prize_draw.php',2);
$x->add_related_link('register for prizes.','chng_prizes.php',1);
$x->add_related_link('view all prizes.','disp_prizes.php',0);

$x->start_elements();
$array = array(1 => '1st', 2 => '2nd', 3 => '3rd', 4 => '4th');
$x->add_text("prizename",1,1,0,"prize name",array("empty" => "you forgot to enter a prize name!"),255);
$x->add_text("prizequantity",1,1,0,"quantity of prize available (numeric input only)",array("empty" => "how many of this prize are available?"),20);
$x->add_text("prizevalue",0,1,0,"value of prize in ".MONEY_SYMBOL." (numeric input only)",array(),12);
$x->add_text("prizepicture",0,1,0,"picture of prize (url can be relative or absolute)",array(),255);
$x->add_text("prizegroup",0,1,0,"drawing group of prize (numeric input only)",array(),11);
$x->add_selectlist("tourneyid",0,1,0,"given away for tournament?",array(),"SELECT * FROM tournaments","tourneyid","name");
$x->add_select("tourneyplace",0,1,0,"placing in tournament required to win prize",array(),$array);

if (empty($_POST) && $x->is_secure() && $dbc->database_num_rows($dbc->database_query("SELECT * FROM prizes_winners")) == 0) {
	$x->display_top();
	$x->display_form();
	$x->display_bottom();
} elseif (!empty($_POST) && $x->is_secure() && $dbc->database_num_rows($dbc->database_query("SELECT * FROM prizes_winners")) == 0) {
	$x->display_results();
} elseif ($dbc->database_result($dbc->database_query("SELECT lock_prizes FROM prizes_control"), 0) == 1) {
	$x->display_slim("prizes cannot be changed because prizes have been locked.","admin_prize_control.php");
} else {
	$x->display_slim('you are not authorized to view this page.');
}
?>